export const createCreateOrUpdateRecording = (recordings) => {
  return (recordingId, sampleRate, typedArrays) => {
    const recording = recordings.get(recordingId);
    if (recording === void 0) {
      const newRecording = {
        channelDataArrays: typedArrays.map((typedArray) => [typedArray]),
        isComplete: true,
        sampleRate
      };
      recordings.set(recordingId, newRecording);
      return newRecording;
    }
    recording.channelDataArrays.forEach((channelDataArray, index) => channelDataArray.push(typedArrays[index]));
    return recording;
  };
};
